<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Тестовое задание: Класс DataBlob</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Тестовое задание
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Создано системой Doxygen 1.8.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Титульная&#160;страница</span></a></li>
      <li class="current"><a href="annotated.html"><span>Классы</span></a></li>
      <li><a href="files.html"><span>Файлы</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Классы</span></a></li>
      <li><a href="classes.html"><span>Алфавитный&#160;указатель&#160;классов</span></a></li>
      <li><a href="functions.html"><span>Члены&#160;классов</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Открытые типы</a> &#124;
<a href="#pub-methods">Открытые члены</a> &#124;
<a href="class_data_blob-members.html">Полный список членов класса</a>  </div>
  <div class="headertitle">
<div class="title">Класс DataBlob</div>  </div>
</div><!--header-->
<div class="contents">

<p>Класс описания Блоба для хранения данных  
 <a href="class_data_blob.html#details">Подробнее...</a></p>

<p><code>#include &lt;<a class="el" href="data__server_8h_source.html">data_server.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Открытые типы</h2></td></tr>
<tr class="memitem:a9542f97660974ad6c323fa95db995a35"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35">errs</a> { <a class="el" href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35ae8d722cb862d40233524fc6cc3108daf">SUCCESS</a>, 
<a class="el" href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35a7246f700ffa6b22526808cd5c2ea7399">ERR_BLOB_NOT_OPENED</a> = -1, 
<a class="el" href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35ad2e9575e6d11ffea6f7feef53060a16b">ERR_BLOB_IS_RO</a> = -2, 
<a class="el" href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35ad6e98cd11371fc20c9848869d1dded4a">ERR_BLOB_IS_FULL</a> = -3
 }</td></tr>
<tr class="memdesc:a9542f97660974ad6c323fa95db995a35"><td class="mdescLeft">&#160;</td><td class="mdescRight">Набор ошибок - результатов выполнения операций  <a href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35">Подробнее...</a><br /></td></tr>
<tr class="separator:a9542f97660974ad6c323fa95db995a35"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Открытые члены</h2></td></tr>
<tr class="memitem:a9b4f7b3499cc73db7e05182f0a07526e"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_data_blob.html#a9b4f7b3499cc73db7e05182f0a07526e">DataBlob</a> (uint64_t blockSize, uint32_t blobSize)</td></tr>
<tr class="separator:a9b4f7b3499cc73db7e05182f0a07526e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a06864e678f669fcf8b06437a0bde6932"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_data_blob.html#a06864e678f669fcf8b06437a0bde6932">~DataBlob</a> ()</td></tr>
<tr class="separator:a06864e678f669fcf8b06437a0bde6932"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae4e775c824396a7c1d2e659d446342bf"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_data_blob.html#ae4e775c824396a7c1d2e659d446342bf">getBlock</a> (uint64_t blockPos, char *blockData)</td></tr>
<tr class="separator:ae4e775c824396a7c1d2e659d446342bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2e46cd3e5128b1a5e166032ac0c3bb2c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_data_blob.html#a2e46cd3e5128b1a5e166032ac0c3bb2c">putBlock</a> (const char *blockData)</td></tr>
<tr class="separator:a2e46cd3e5128b1a5e166032ac0c3bb2c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af5fc4605df9eae3c7a82a9fa2357e5fc"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_data_blob.html#af5fc4605df9eae3c7a82a9fa2357e5fc">getPosition</a> ()</td></tr>
<tr class="separator:af5fc4605df9eae3c7a82a9fa2357e5fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aab73e4531543bbc630eb73eddb8b7782"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_data_blob.html#aab73e4531543bbc630eb73eddb8b7782">getFilename</a> ()</td></tr>
<tr class="separator:aab73e4531543bbc630eb73eddb8b7782"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa258a2624b31643a2dcc24618709fe43"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_data_blob.html#aa258a2624b31643a2dcc24618709fe43">open</a> (string fileName)</td></tr>
<tr class="separator:aa258a2624b31643a2dcc24618709fe43"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Подробное описание</h2>
<div class="textblock"><p>Класс описания Блоба для хранения данных </p>
<p>Класс, определяющий логику хранения блоков данных на диске (блоб) </p>
</div><h2 class="groupheader">Перечисления</h2>
<a class="anchor" id="a9542f97660974ad6c323fa95db995a35"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="class_data_blob.html#a9542f97660974ad6c323fa95db995a35">DataBlob::errs</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Набор ошибок - результатов выполнения операций </p>
<table class="fieldtable">
<tr><th colspan="2">Элементы перечислений</th></tr><tr><td class="fieldname"><a class="anchor" id="a9542f97660974ad6c323fa95db995a35ae8d722cb862d40233524fc6cc3108daf"></a>SUCCESS&#160;</td><td class="fielddoc">
<p>успешное выполнение </p>
</td></tr>
<tr><td class="fieldname"><a class="anchor" id="a9542f97660974ad6c323fa95db995a35a7246f700ffa6b22526808cd5c2ea7399"></a>ERR_BLOB_NOT_OPENED&#160;</td><td class="fielddoc">
<p>открытие блоба завершилось ошибкой </p>
</td></tr>
<tr><td class="fieldname"><a class="anchor" id="a9542f97660974ad6c323fa95db995a35ad2e9575e6d11ffea6f7feef53060a16b"></a>ERR_BLOB_IS_RO&#160;</td><td class="fielddoc">
<p>блоб открыт в режиме только для чтения </p>
</td></tr>
<tr><td class="fieldname"><a class="anchor" id="a9542f97660974ad6c323fa95db995a35ad6e98cd11371fc20c9848869d1dded4a"></a>ERR_BLOB_IS_FULL&#160;</td><td class="fielddoc">
<p>блоб заполнен </p>
</td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Конструктор(ы)</h2>
<a class="anchor" id="a9b4f7b3499cc73db7e05182f0a07526e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DataBlob::DataBlob </td>
          <td>(</td>
          <td class="paramtype">uint64_t&#160;</td>
          <td class="paramname"><em>blockSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>blobSize</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Конструктор класса</p>
<p>Данные в блобе хранятся последовательно блоками заданной в конструкторе длины. Запись блоков происходит последовательно. Перезапись и удаление данных не предусмотрено в рамках тестового задания. Чтение блоков происходит посредством вычисления из указанной позиции смещения относительно начала файла.</p>
<dl class="params"><dt>Аргументы</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">blockSize</td><td>размер блока данных </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">blobSize</td><td>размер блоба данных (в блоках) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a06864e678f669fcf8b06437a0bde6932"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DataBlob::~DataBlob </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Деструктор класса </p>

</div>
</div>
<h2 class="groupheader">Методы</h2>
<a class="anchor" id="ae4e775c824396a7c1d2e659d446342bf"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int DataBlob::getBlock </td>
          <td>(</td>
          <td class="paramtype">uint64_t&#160;</td>
          <td class="paramname"><em>blockPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>blockData</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Возвращает блок по указанной позиции в блобе</p>
<dl class="params"><dt>Аргументы</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">blockPos</td><td>позиция блока в блобе </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">blockData</td><td>указатель на прочитанный блок</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Возвращает</dt><dd>результат выполнения операции (не ноль - ошибка) </dd></dl>

</div>
</div>
<a class="anchor" id="aab73e4531543bbc630eb73eddb8b7782"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string DataBlob::getFilename </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Возвращает имя файла, в который записан текущий блоб</p>
<dl class="section return"><dt>Возвращает</dt><dd>имя файла </dd></dl>

</div>
</div>
<a class="anchor" id="af5fc4605df9eae3c7a82a9fa2357e5fc"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int DataBlob::getPosition </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Возвращает текущую позицию в блобе</p>
<dl class="section return"><dt>Возвращает</dt><dd>текущая позиция </dd></dl>

</div>
</div>
<a class="anchor" id="aa258a2624b31643a2dcc24618709fe43"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int DataBlob::open </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>fileName</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Открывает файл блоба на диске</p>
<dl class="params"><dt>Аргументы</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">fileName</td><td>имя открываемого файла</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Возвращает</dt><dd>результат выполнения операции (не ноль - ошибка) </dd></dl>

</div>
</div>
<a class="anchor" id="a2e46cd3e5128b1a5e166032ac0c3bb2c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int DataBlob::putBlock </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>blockData</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Помещает блок в блоб</p>
<dl class="params"><dt>Аргументы</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">blockData</td><td>указатель на помещаемый блок</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Возвращает</dt><dd>результат выполнения операции (не ноль - ошибка) </dd></dl>

</div>
</div>
<hr/>Объявления и описания членов классов находятся в файлах:<ul>
<li><a class="el" href="data__server_8h_source.html">data_server.h</a></li>
<li>data_server.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Документация по Тестовое задание. Последние изменения: Вт 13 Сен 2016 20:23:58. Создано системой &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.9.1
</small></address>
</body>
</html>
